package org.hisp.dhis.mobile.recordstore;

/*
 * Copyright (c) 2004-2011, University of Oslo All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the
 * following conditions are met: * Redistributions of source code must retain the above copyright notice, this list of
 * conditions and the following disclaimer. * Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation and/or other materials provided with the
 * distribution. * Neither the name of the HISP project nor the names of its contributors may be used to endorse or
 * promote products derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

import javax.microedition.rms.RecordStoreException;

import org.hisp.dhis.mobile.model.OrgUnit;

public class OrgUnitRecordStore
{
    public static final String ORG_UNIT_DB = "ORG_UNIT";

    public static void saveOrgUnit( OrgUnit orgUnit )
    {
        try
        {
            SettingRecordStore orgUnitRecord = new SettingRecordStore( ORG_UNIT_DB );
            // SettingsRecordStore orgUnitRecord = new SettingsRecordStore(
            // ORG_UNIT_DB );
            orgUnitRecord.put( "id", "" + orgUnit.getId() );
            orgUnitRecord.put( "name", orgUnit.getName() );
            orgUnitRecord.put( "activityplan", orgUnit.getUpdateActivityPlanUrl() );
            orgUnitRecord.put( "all", orgUnit.getDownloadAllUrl() );
            orgUnitRecord.put( "saveActivity", orgUnit.getUploadActivityReportUrl() );
            orgUnitRecord.put( "saveFacility", orgUnit.getUploadFacilityReportUrl() );
            orgUnitRecord.put( "updateDataSet", orgUnit.getUpdateDataSetsUrl() );
            orgUnitRecord.put( "changeDataSetLangUrl", orgUnit.getChangeDataSetLangUrl() );
            orgUnitRecord.put( "searchUrl", orgUnit.getSearchUrl() );
            orgUnitRecord.save();
        }
        catch ( RecordStoreException rse )
        {
            rse.printStackTrace();
        }
    }

    public static OrgUnit loadOrgUnit()
    {
        OrgUnit orgUnit = new OrgUnit();

        try
        {
            SettingRecordStore store = new SettingRecordStore( ORG_UNIT_DB );
            String id = store.get( "id" );

            // First time
            if ( id == null || id.length() == 0 )
            {
                return null;
            }

            orgUnit.setId( Integer.parseInt( id ) );
            orgUnit.setName( store.get( "name" ) );
            orgUnit.setUpdateActivityPlanUrl( store.get( "activityplan" ) );
            orgUnit.setDownloadAllUrl( store.get( "all" ) );
            orgUnit.setUploadActivityReportUrl( store.get( "saveActivity" ) );
            orgUnit.setUploadFacilityReportUrl( store.get( "saveFacility" ) );
            orgUnit.setUpdateDataSetsUrl( store.get( "updateDataSet" ) );
            orgUnit.setChangeDataSetLangUrl( store.get( "changeDataSetLangUrl" ) );
            orgUnit.setSearchUrl( store.get( "searchUrl" ) );
            return orgUnit;
        }
        catch ( RecordStoreException e )
        {
            System.out.println( e.getMessage() );
            e.printStackTrace();
        }
        return null;
    }
}
