package org.hisp.dhis.mobile.ui;

import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Graphics;
import org.hisp.dhis.mobile.midlet.FacilityMIDlet;

public class CalendarCanvas
    extends Canvas
    implements CommandListener
{
    CalendarWidget calendar = null;

    private FacilityMIDlet dhisMIDlet;

    Command selectDateCmd = null;

    public CalendarCanvas( FacilityMIDlet dhisMIDlet )
    {
        this.dhisMIDlet = dhisMIDlet;
        calendar = new CalendarWidget( dhisMIDlet.getPeriodView().getDailyPeriodDateField().getDate() );
        calendar.initialize();
        selectDateCmd = new Command( "Select", Command.OK, 1 );
        setCommandListener( this );
        addCommand( selectDateCmd );
    }

    protected void keyPressed( int key )
    {
        int keyCode = getGameAction( key );
        if ( keyCode == FIRE )
        {
            dhisMIDlet.getPeriodView().showView();
        }
        else
        {
            calendar.keyPressed( keyCode );
            repaint();
        }
    }

    protected void paint( Graphics g )
    {
        g.setColor( 0xffffff );
        g.fillRect( 0, 0, getWidth(), getHeight() );
        calendar.paint( g );
    }

    public void commandAction( Command c, Displayable d )
    {

        if ( c == selectDateCmd )
        {
            if ( c.getCommandType() == 4 )
            {
                dhisMIDlet.getPeriodView().getDailyPeriodDateField().setDate( calendar.getSelectedDate() );
                dhisMIDlet.getPeriodView().showView();
            }
        }
    }
}
