package org.hisp.dhis.mobile.view;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.TextField;
import javax.microedition.rms.RecordStoreException;
import org.hisp.dhis.mobile.connection.ConnectionManager;
import org.hisp.dhis.mobile.midlet.DHISMIDlet;
import org.hisp.dhis.mobile.midlet.NameBasedMIDlet;
import org.hisp.dhis.mobile.model.OrgUnit;
import org.hisp.dhis.mobile.recordstore.OrgUnitRecordStore;
import org.hisp.dhis.mobile.recordstore.SettingRecordStore;
import org.hisp.dhis.mobile.ui.Text;

public class FindBeneficiaryView
    extends AbstractView
    implements CommandListener
{
    private Form findBeneficiaryForm;

    private TextField keywordTextField;

    private Command findBeneficiaryFindCommand;

    private Command findBeneficiaryBackCommand;

    private NameBasedMIDlet nameBasedMIDlet;

    public FindBeneficiaryView( DHISMIDlet dhisMIDlet )
    {
        super( dhisMIDlet );
        this.nameBasedMIDlet = (NameBasedMIDlet) this.dhisMIDlet;
    }

    public void prepareView()
    {

    }

    public void showView()
    {
        this.switchDisplayable( null, this.getFindBeneficiaryForm() );
    }

    public void commandAction( Command command, Displayable displayable )
    {
        if ( command == this.findBeneficiaryFindCommand )
        {
            nameBasedMIDlet.getWaitingView().showView();

            OrgUnit orgUnit = OrgUnitRecordStore.loadOrgUnit();
            SettingRecordStore settingStore = null;

            try
            {
                settingStore = new SettingRecordStore();
            }
            catch ( RecordStoreException e )
            {
                e.printStackTrace();
            }

            ConnectionManager.init( nameBasedMIDlet, orgUnit.getSearchUrl(),
                settingStore.get( SettingRecordStore.USERNAME ), settingStore.get( SettingRecordStore.PASSWORD ),
                settingStore.get( SettingRecordStore.LOCALE ), orgUnit );
            ConnectionManager.uploadBeneficiaryIdentifier( this.getKeywordTextField().getString().trim() );
        }
        else if ( command == this.findBeneficiaryBackCommand )
        {
            nameBasedMIDlet.getActivityMainMenuView().showView();
        }

    }

    public Form getFindBeneficiaryForm()
    {
        if ( findBeneficiaryForm == null )
        {
            findBeneficiaryForm = new Form( Text.FIND() );
            findBeneficiaryForm.addCommand( this.getFindBeneficiaryFindCommand() );
            findBeneficiaryForm.addCommand( this.getFindBeneficiaryBackCommand() );
            findBeneficiaryForm.append( this.getKeywordTextField() );
            findBeneficiaryForm.append( Text.SEARCH_HINT() );
            findBeneficiaryForm.setCommandListener( this );
        }
        return findBeneficiaryForm;
    }

    public void setFindBeneficiaryForm( Form findBenficiaryForm )
    {
        this.findBeneficiaryForm = findBenficiaryForm;
    }

    public TextField getKeywordTextField()
    {
        if ( keywordTextField == null )
        {
            keywordTextField = new TextField( Text.ENTER_KEY_WORD(), "", 32, TextField.ANY );
        }
        return keywordTextField;
    }

    public void setKeywordTextField( TextField keywordTextField )
    {
        this.keywordTextField = keywordTextField;
    }

    public Command getFindBeneficiaryFindCommand()
    {
        if ( findBeneficiaryFindCommand == null )
        {
            findBeneficiaryFindCommand = new Command( Text.FIND(), Command.SCREEN, 0 );
        }
        return findBeneficiaryFindCommand;
    }

    public void setFindBeneficiaryFindCommand( Command findBeneficiaryFindCommand )
    {
        this.findBeneficiaryFindCommand = findBeneficiaryFindCommand;
    }

    public Command getFindBeneficiaryBackCommand()
    {
        if ( findBeneficiaryBackCommand == null )
        {
            findBeneficiaryBackCommand = new Command( Text.BACK(), Command.BACK, 0 );
        }
        return findBeneficiaryBackCommand;
    }

    public void setFindBeneficiaryBackCommand( Command findBeneficiaryBackCommand )
    {
        this.findBeneficiaryBackCommand = findBeneficiaryBackCommand;
    }

}
